﻿Imports MySql.Data.MySqlClient

Module DB

    Dim MysqlConn As New MySqlConnection
    Public con As MySqlConnection = myconn()

    Dim cmd As New MySqlCommand
    Dim result As Integer

    Dim da As New MySqlDataAdapter
    Dim dt As New DataTable
    Dim dReader As MySqlDataReader

    Public module_id As Integer
    Public question_id As Integer
    Public answercorrect As Integer

    Public item As Integer
    Public itemtotal As Integer
    Public randomseq As String

    Public totalscore As Integer

    Public accountid As Integer

    Public department As String

    Public accountname As String
    Public modulename As String

    Public scorepercent As Double

    Public taketime As String
    Public takedate As String
    Public remarks As String
    Public answerid As Integer

    Public myseatno As Integer

    Public answerletter As String

    Public itemscore As Integer

    Public Function myconn() As MySqlConnection
        Return New MySqlConnection("server=localhost;user id=root;password='';database=kcctbs")
    End Function

    Public Sub findthis(ByVal sql As String)
        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql
            End With
        Catch ex As Exception

            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        Finally

            da.Dispose()
            con.Close()

        End Try

    End Sub

    Public Sub LoadData(ByVal obj As Object, ByVal param As String)
        Try
            con.Open()
            dReader = cmd.ExecuteReader()

            Select Case param
                Case "resultstud"
                    Do While dReader.Read = True
                        obj.Rows.Add(dReader(0), dReader(1), dReader(2), dReader(3), dReader(4))
                    Loop
                Case "loadresult"
                    Do While dReader.Read = True
                        obj.Rows.Add(dReader(0), dReader(1), dReader(2), dReader(3), dReader(4), dReader(5), dReader(6), dReader(7))
                    Loop
                Case "ModuleExam"
                    Do While dReader.Read = True
                        obj.Rows.Add(dReader(0), dReader(1))
                    Loop

                Case "LoadUsers"
                    Do While dReader.Read = True
                        obj.Rows.Add(dReader(0), dReader(1), dReader(2), dReader(3))
                    Loop

                Case "loadModule"
                    Do While dReader.Read = True
                        obj.Rows.Add(dReader(0), dReader(1), dReader(2))
                    Loop

                Case "loadQuestions"
                    Do While dReader.Read = True
                        obj.Rows.Add(dReader(0), dReader(2))
                    Loop

                Case "LoadAnswers"
                    Do While dReader.Read = True
                        obj.Rows.Add(dReader(0), dReader(1), dReader(2), dReader(3))
                    Loop

                Case "ExamAnsLoad"
                    Do While dReader.Read = True
                        obj.Rows.Add(dReader(0), dReader(1))
                    Loop

            End Select

        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            da.Dispose()
            con.Close()
        End Try
    End Sub

    Public Function saveInsert(ByVal sql As String) As Boolean

        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql

                result = cmd.ExecuteNonQuery
                If result = 0 Then
                    Return False
                Else
                    Return True
                End If
            End With
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information)
        Finally
            da.Dispose()
            con.Close()

        End Try

    End Function

    Public Function UpdateSave(ByVal sql As String) As Boolean
        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql
                result = cmd.ExecuteNonQuery
                If result = 0 Then

                    Return False
                Else
                    Return True

                End If
            End With
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information)
        Finally
            con.Close()

        End Try

    End Function

    Public Function DeleteSave(ByVal sql As String) As Boolean
        Try
            con.Open()
            With cmd
                .Connection = con
                .CommandText = sql
                result = cmd.ExecuteNonQuery
                If result = 0 Then
                    Return False
                Else
                    Return True
                End If
            End With
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information)
        Finally
            con.Close()

        End Try

    End Function


    Public Sub CheckResult(ByVal CaseResult As String)
        Dim table As New DataTable
        Try

            da.SelectCommand = cmd
            da.Fill(table)

            If table.Rows.Count > 0 Then
                Select Case CaseResult

                    Case "Login"
                        If table.Rows(0).Item(0) = "Dean" Then
                            With Form1
                                .tsGenerate.Enabled = True
                                .tsTest.Enabled = True
                                .tsSettings.Enabled = True
                                .tsReports.Enabled = True
                                .tsView.Enabled = True
                                .tsItem.Enabled = True

                                .tsLogin.Text = "Logout"
                                MsgBox("Welcome, You Login as Dean!")
                                LoginForm1.Close()

                            End With

                        ElseIf table.Rows(0).Item(0) = "Student" Then
                            With Form1

                                department = table.Rows(0).Item(1)
                                accountid = table.Rows(0).Item(2)
                                accountname = table.Rows(0).Item(3)
                                myseatno = table.Rows(0).Item(4)
                                .tsItem.Enabled = True
                                .tsTest.Enabled = True

                                .tsLogin.Text = "Logout"
                                LoginForm1.Close()

                            End With


                        ElseIf table.Rows(0).Item(0) = "Teacher" Then
                            With Form1
                                .tsGenerate.Enabled = True
                                .tsReports.Enabled = True
                                .tsView.Enabled = True
                                .tsItem.Enabled = True

                                .tsLogin.Text = "Logout"
                                LoginForm1.Close()

                            End With

                        End If


                    Case "Examination"
                        item = table.Rows(0).Item(0)
                        itemtotal = table.Rows(0).Item(0)
                        randomseq = table.Rows(0).Item(1)

                        'frmSelectModule.Close()
                        frmExamination.Show()

                    Case "ExamProper"

                        If randomseq = "Even" Then

                            frmExamination.txtQuestion.Text = table.Rows(1).Item(0)
                            question_id = table.Rows(1).Item(1)

                        ElseIf randomseq = "Odd" Then
                            frmExamination.txtQuestion.Text = table.Rows(0).Item(0)
                            question_id = table.Rows(0).Item(1)

                        ElseIf randomseq = "Normal" Then
                            frmExamination.txtQuestion.Text = table.Rows(0).Item(0)
                            question_id = table.Rows(0).Item(1)

                        End If


                    Case "ExamProperNext"

                        frmExamination.txtQuestion.Text = table.Rows(0).Item(0)
                        'question_id = table.Rows(1).Item(1)

                    Case "ExamProperBack"
                        frmExamination.txtQuestion.Text = table.Rows(0).Item(0)

                    Case "ComputeScore"
                        totalscore += table.Rows(0).Item(0)

                        itemscore = table.Rows(0).Item(0)


                        findthis("SELECT * FROM `tblitemanalysis` WHERE `TAKENO` =" & frmSelectModule.txtTakeNo.Text & " and `IDNO` = " & accountid & " and `MODULEID` =" & module_id & " and `QUESTIONID` =" & question_id & "")
                        CheckResult("ItemAnalysis")


                    Case "CheckExist"
                        With frmSetTest
                            UpdateSave("UPDATE `tblrandomset` set `MOD_ID` = " & .cbModules.SelectedValue & ", `RANDSEQUENCE` ='" & .cbRandom.Text & "', `TOTALITEMS` = " & .txtNoItems.Text & " where `randomid` = " & table.Rows(0).Item(0) & "")
                            .Close()

                        End With


                End Select
            Else
                Select Case CaseResult

                    Case "ItemAnalysis"


                        saveInsert("INSERT INTO `tblitemanalysis` (`IDNO`, `MODULEID`, `QUESTIONID`, `ITEMSCORE`, `TAKENO`)" & _
   " VALUES (" & accountid & "," & module_id & "," & question_id & "," & itemscore & "," & frmSelectModule.txtTakeNo.Text & ")")



                    Case "Login"
                        MsgBox("Contact Administrator.")

                    Case "Examination"
                        MsgBox("Examination not set.")
                        frmSelectModule.Close()

                    Case "CheckExist"
                        With frmSetTest

                            saveInsert("INSERT INTO `tblRandomSet` (`MOD_ID`, `TOTALITEMS`, `RANDSEQUENCE`)" & _
                 " VALUES (" & .cbModules.SelectedValue & "," & .txtNoItems.Text & ",'" & .cbRandom.Text & "')")

                            .Close()
                        End With


                End Select
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            da.Dispose()
            con.Close()
        End Try
    End Sub

    Public Sub fillcombo(ByVal combo As Object, ByVal member As String, ByVal idparam As String)
        Dim publictable As New DataTable
        Try
            da.SelectCommand = cmd
            da.Fill(publictable)
            With combo
                .DataSource = publictable
                .displaymember = member
                .valuemember = idparam
                .SelectedIndex = -1
            End With

            da.Dispose()

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information)
        End Try
    End Sub

    Public Sub LoadSingleData(ByVal param As String)
        Try
            con.Open()
            dReader = cmd.ExecuteReader()

            Select Case param
                Case "Editanswer"
                    Do While dReader.Read = True
                        With frmAnswers
                            answerid = dReader("answerid")
                            .txtLetter.Text = dReader("answer_letter")
                            .txtAnswer.Text = dReader("answer_choice")
                            If dReader("correct_answer") = 1 Then
                                .cbCorrect.Checked = True
                            Else
                                .cbCorrect.Checked = False

                            End If
                            .btnSave.Text = "Update"
                        End With
                    Loop
                Case "SingleUsers"
                    Do While dReader.Read = True
                        With frmUserAccountsProfile

                            accountid = dReader("ACCOUNT_ID")

                            .txtIDNO.Text = dReader("IDNO")
                            .txtname.Text = dReader("ACCOUNT_NAME")
                            .txtUsername.Text = dReader("ACCOUNT_USERNAME")
                            .txtpass.Text = dReader("ACCOUNT_PASSWORD")
                            .cbtype.Text = dReader("ACCOUNT_TYPE")
                            .cbDepartment.Text = dReader("DEPARTMENT")
                            .btnSave.Text = "Update"
                        End With
                    Loop

                Case "EditModules"
                    Do While dReader.Read = True
                        With frmNewModule
                            module_id = dReader("MOD_ID")
                            .txtName.Text = dReader("MODULE_NAME")
                            .txtDescription.Text = dReader("MODULE_DESCRIPTION")
                            .txtdepartment.Text = dReader("DEPARTMENT")
                            .Show()
                            .btnSave.Text = "Update"
                        End With
                    Loop

            End Select

        Catch ex As Exception
            MsgBox(ex.Message)

        Finally
            da.Dispose()
            con.Close()
        End Try
    End Sub
    Public Sub reporttbs(ByVal RpTsql As String, ByVal rptname As String)
        dt = New DataTable
        Try
            myconn.Open()
            cmd.Connection = myconn()
            cmd.CommandText = RpTsql
            da.SelectCommand = cmd
            da.Fill(dt)

            Dim reportpath As String = Application.StartupPath & "\reports\" & rptname & ".rpt"
            If Not IO.File.Exists(reportpath) Then
                MsgBox("Unable to locate file")
            End If
            Dim reportdoc As New CrystalDecisions.CrystalReports.Engine.ReportDocument

            reportdoc.Load(reportpath)
            reportdoc.SetDataSource(dt)

            With report
                .CrystalReportViewer1.ReportSource = reportdoc
                .Show()

            End With
        Catch ex As Exception
            MsgBox(ex.Message)
        Finally
            myconn.Close()

        End Try


    End Sub

End Module
